<?PHP
/* 	SIGNUM-NET, FARA 5.0
	SKRYPT DO OBSŁUGI MODUŁU CMENTARZ ONLINE
	AKTUALIZACJA: 20.04.2020
	- zmiany:
	- w tabeli fara_pochowani i fara_pochowani_archiwum dodano kolumnę grvid zawierajacą
	- systenmowy identyfikator grobu (fara_id z tabeli fara_groby) o ile gróbw ten 
	- faktycznie istnieje w księdze grobów (FARA dopuszcza możliwość prowadzenia
	- ewidencji skróconej, tylko do celów pomocniczych, w której ewidencjonuej się
	- tylko pochowanych)
*/
define ("FARA_CEMETERY_SOURCE_FOLDER"	, 'fara-cmentarz-online');

define ("FARA_GRAVES_TABLE"				, 'faraGroby');
define ("FARA_BURIEDS_TABLE"			, 'faraPochowani');
define ("FARA_BURIEDS_ARCHIVE_TABLE"	, 'faraPochowaniArchiwum');
define ("FARA_CEMETERIES_TABLE"			, 'faraCmentarze');
define ("FARA_GRAVES_PICTURES_TABLE"	, 'faraGrobyFotografie');

define ("FARA_GRAVES_FILE_TYPE"			, 'fara_groby');
define ("FARA_BURIEDS_FILE_TYPE"		, 'fara_pochowani');
define ("FARA_BURIEDS_ARCHIVE_FILE_TYPE", 'fara_pochowani_archiwum');
define ("FARA_CEMETERIES_FILE_TYPE"		, 'fara_cmentarze');
define ("FARA_GRAVES_PICTURES_FILE_TYPE", 'fara_cmentarz_fotografie');

$faraCmentarz = new FaraCemetery();

if (isset ($_GET['tryb']) and strtolower ($_GET['tryb'])=='instaluj') $faraCmentarz->install();
if (isset ($_GET['tryb']) and strtolower ($_GET['tryb'])=='upgrade') $faraCmentarz->upgrade();
if (isset ($_GET['loading']) and $_GET['loading']==1) $faraCmentarz->dataLoad(FARA_CEMETERY_SOURCE_FOLDER);

class FaraCemetery {
	var $dbSourceFolder 			= '';
	var $emailToSendErrorMessage	= '';
	var $emailSender				= '';

function __construct () {
require_once ('fara_cmentarz_online_konfiguracja.php');
$this->emailToSendErrorMessage 	= $emailToSendErrorMessage;
$this->emailSender				= $emailSender;
$this->dbSourceFolder			= $mainFolder.FARA_CEMETERY_SOURCE_FOLDER;
@mysql_connect($dbHost, $dbUser, $dbPassword) or $this->sendErrorMessage ('Brak połączenia z bazą danych');
mysql_select_db($dbName);
}

function sendErrorMessage ($command) {
if (strlen ($this->emailToSendErrorMessage) > 0) {
	mail ($this->emailToSendErrorMessage, 
		  'Komunikat o błędzie w trakcie obsługi bazy cmentarza na stronie WWW', 
		  $command,
		  '',
		  '-f'.$this->emailSender);
}
}

// INSTALACJA - TWORZENIE TABLICY
function install () {
$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_CEMETERIES_TABLE.'` (`faraID` integer NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`adres` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`poziomy` integer NOT NULL,`p1` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p2` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p3` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p4` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p5` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p6` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p7` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p8` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles = mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli cmentarzy)");

$query 		= 'CREATE TABLE IF NOT EXISTS `'.FARA_GRAVES_TABLE.'` (`faraID` integer NOT NULL, `cmentarzID` integer NOT NULL,`zabytek` integer NOT NULL,`nieczytelny` integer NOT NULL,`dzieciecy` integer NOT NULL, `wygasa` VARCHAR (10) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`doLikwidacji` BOOLEAN NOT NULL, `zwolniony` BOOLEAN NOT NULL, `wieczysty` BOOLEAN NOT NULL, `p1` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p2` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p3` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p4` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p5` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p6` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p7` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p8` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`komentarz` VARCHAR (100) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli grobów)");
$query 		= 'ALTER TABLE `'.FARA_GRAVES_TABLE.'` ADD INDEX (`faraID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli grobów)");
$query 		= 'ALTER TABLE `'.FARA_GRAVES_TABLE.'` ADD INDEX (`cmentarzID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli grobów)");
$query 		= 'ALTER TABLE `'.FARA_GRAVES_TABLE.'` ADD INDEX (`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli grobów)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_BURIEDS_TABLE.'`(`faraID` integer NOT NULL,`cmentarzID` integer NOT NULL, `nazwisko` VARCHAR (75) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `imie` VARCHAR (75) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `dataUrodzenia` VARCHAR (10) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `dataSmierci` VARCHAR (10) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `p1` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p2` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p3` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p4` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p5` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p6` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p7` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p8` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `grvid` integer NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_TABLE.'` ADD INDEX (`faraID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_TABLE.'` ADD INDEX (`cmentarzID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_TABLE.'` ADD INDEX (`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_TABLE.'` ADD INDEX (`nazwisko`, `imie`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_BURIEDS_ARCHIVE_TABLE.'`(`faraID` integer NOT NULL,`cmentarzID` integer NOT NULL, `nazwisko` VARCHAR (75) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `imie` VARCHAR (75) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `dataUrodzenia` VARCHAR (10) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `dataSmierci` VARCHAR (10) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `p1` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p2` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p3` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p4` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p5` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p6` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p7` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`p8` VARCHAR (30) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`powod` VARCHAR (75) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `grvid` integer NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_ARCHIVE_TABLE.'` ADD INDEX (`faraID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_ARCHIVE_TABLE.'` ADD INDEX (`cmentarzID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_ARCHIVE_TABLE.'` ADD INDEX (`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");
$query 		= 'ALTER TABLE `'.FARA_BURIEDS_ARCHIVE_TABLE.'` ADD INDEX (`nazwisko`, `imie`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli pochowanych)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_GRAVES_PICTURES_TABLE.'` (`faraID` integer NOT NULL, `cmentarzID` integer NOT NULL, `grobID` integer NOT NULL, `typ` integer NOT NULL, `plikLokalny` VARCHAR (1000) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `plikNaSerwerze` VARCHAR (1000) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli zdjęć)");
$query 		= 'ALTER TABLE `'.FARA_GRAVES_PICTURES_TABLE.'` ADD INDEX (`faraID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli zdjęć)");
$query 		= 'ALTER TABLE `'.FARA_GRAVES_PICTURES_TABLE.'` ADD INDEX (`grobID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli zdjęć)");

mysqli_query ($this->con, "CREATE FUNCTION fromRoman (inRoman varchar(15)) RETURNS integer DETERMINISTIC
BEGIN

    DECLARE numeral CHAR(7) DEFAULT 'IVXLCDM';

    DECLARE digit TINYINT;
    DECLARE previous INT DEFAULT 0;
    DECLARE current INT;
    DECLARE sum INT DEFAULT 0;

    SET inRoman = UPPER(inRoman);

    WHILE LENGTH(inRoman) > 0 DO
        SET digit := LOCATE(RIGHT(inRoman, 1), numeral) - 1;
        SET current := POW(10, FLOOR(digit / 2)) * POW(5, MOD(digit, 2));
        SET sum := sum + POW(-1, current < previous) * current;
        SET previous := current;
        SET inRoman = LEFT(inRoman, LENGTH(inRoman) - 1);
    END WHILE;

    RETURN sum;
END");

mysqli_query ($this->con, "DROP VIEW IF EXISTS ".FARA_FREE_PLACES_VIEW);
mysqli_query ($this->con, "CREATE VIEW ".FARA_FREE_PLACES_VIEW." AS SELECT ".FARA_GRAVES_TABLE.".faraID, ".FARA_GRAVES_TABLE.".cmentarzID, ".
		FARA_GRAVES_TABLE.".p1 AS p1, ".FARA_GRAVES_TABLE.".p2 AS p2, ".
		FARA_GRAVES_TABLE.".p3 AS p3, ".FARA_GRAVES_TABLE.".p4 AS p4, ".FARA_GRAVES_TABLE.".p5 AS p5, ".
		FARA_GRAVES_TABLE.".p6 AS p6, ".FARA_GRAVES_TABLE.".p7 AS p7, ".FARA_GRAVES_TABLE.".p8 AS p8, ".
		FARA_GRAVES_PICTURES_TABLE.".plikNaSerwerze AS imageFile ".
		"FROM ".FARA_GRAVES_TABLE." LEFT JOIN ".FARA_GRAVES_PICTURES_TABLE." ON ".
		FARA_GRAVES_PICTURES_TABLE.".grobID = ".FARA_GRAVES_TABLE.".faraID ".
		"WHERE (".FARA_GRAVES_TABLE.".wygasa='') AND (concat(".FARA_GRAVES_TABLE.".cmentarzID, p1, p2, p3, p4, p5, p6, p7, p8) not in (SELECT concat(cmentarzID, p1, p2, p3, p4, p5, p6, p7, p8) FROM ".FARA_BURIEDS_TABLE."))");


$message	= '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			  '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			  'Instalacja została zakończona.<br/>W bazie danych zostały utworzone tablice:<ul>'.
			  '<li>'.FARA_GRAVES_TABLE.'</li>'.
			  '<li>'.FARA_BURIEDS_TABLE.'</li>'.
			  '<li>'.FARA_BURIEDS_ARCHIVE_TABLE.'</li>'.
			  '<li>'.FARA_CEMETERIES_TABLE.'</li>'.
			  '<li>'.FARA_GRAVES_PICTURES_TABLE.'</li>'.
			  '</ul><br/>Proszę teraz wykonać pozostałe kroki konfiguracyjne'.
			  '</p></body></html>';
echo $message;			  
}

// ŁADOWANIE DANYCH Z PLIKÓW 
function dataLoad () {
$sourceDir = (func_num_args () > 0) ? func_get_arg (0) : $this->dbSourceFolder;
$pathHandle = opendir ($sourceDir);
if (!$pathHandle) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo 'Nie można odczytać zawartości katalogu: '.$sourceDir.'<br/>Ładowanie nie powiodło się';
	  else				
		$this->sendErrorMessage ('Nie można odczytać zawartości katalogu: '.$sourceDir);
	return;
}
$clear = (isset ($_GET['clear']) and $_GET['clear']==1);
// Reset bazy
if ($clear) {
	// SKASOWANIE CAŁOŚCI
	$query = 'DELETE FROM  `'.FARA_GRAVES_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_BURIEDS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);	
	$query = 'DELETE FROM  `'.FARA_BURIEDS_ARCHIVE_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);	
	$query = 'DELETE FROM  `'.FARA_CEMETERIES_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_GRAVES_PICTURES_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
}	
$total = 0;

// APPEND BLANK -> REPLACE MOŻE SPOWODWAĆ POWSTANIE 2 PLIKÓW DLA TEGO SAMEGO ID - TRZEBA TE PLIKI TAK POSORTOWAĆ
// ŻEBY NAJPIERW PRZETWARZAĆ PLIKI STARSZE, A POTEM CORAZ MŁODSZE
// PLIKI TRZEBA WIĘC NAJPIERW POSORTOWAĆ WG. FUNKCJI FILEMTIME, a dopiero potem przetwarzać

while (false !== ($file = readdir($pathHandle))) 
	if (is_file ($sourceDir.'/'.$file)) {
		$localOrderInSession 	= substr ($file, 0, 6);
		$timeSignature			= substr ($file, 6, 16);
		$userID					= substr ($file, 22, 5);
		$key = $timeSignature.$localOrderInSession.$userID;				
		$files[$key] = $file;
	}
	
if (!isset ($files) or count ($files)==0) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			'<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			'Ładowanie zostało przeprowadzone, ale nie znaleziono żadnych danych do wczytania'.
			'</p></body></html>';
	return ;
}
ksort ($files);
closedir($pathHandle);
foreach ($files as $file) {
	$path = $sourceDir.'/'.$file;
	if 		(is_file ($path) and $this->fileNameExtension($path)==FARA_GRAVES_FILE_TYPE ) $total += $this->loadGraves($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_BURIEDS_FILE_TYPE)$total += $this->loadBurieds($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_BURIEDS_ARCHIVE_FILE_TYPE)$total += $this->loadBuriedsArchive($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_CEMETERIES_FILE_TYPE) $total += $this->loadCemeteries($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_GRAVES_PICTURES_FILE_TYPE) $total += $this->loadPictures($path);			 
}

if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
	echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
		 '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
		 'Ładowanie danych zostało wykonane. Liczba zmian: '.$total.
		 '</p></body></html>';
}

function unpackText ($text) {
$content = trim (str_replace ('&pipe', '|', $text));
return $content;
}

// Księga grobów
function loadGraves ($path) {
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, cmentarz, zabytek, nieczytelny, dziecięcy, wygasa, P1..P8
	$id			= intval (trim ($info [0]));	
	if ($id==0) continue;
	$cmentarz	= $info [1];	
	$zabytek	= $info [2];
	$nieczytelny= $info [3];
	$dziecko	= $info [4];
	$wygasa		= $info [5];	
	$P1			= $this->unpackText ($info [6]);	
	$P2			= $this->unpackText ($info [7]);	
	$P3			= $this->unpackText ($info [8]);	
	$P4			= $this->unpackText ($info [9]);	
	$P5			= $this->unpackText ($info [10]);	
	$P6			= $this->unpackText ($info [11]);	
	$P7			= $this->unpackText ($info [12]);	
	$P8			= $this->unpackText ($info [13]);	
	if ($id<0) {
		$query	= 'DELETE FROM `'.FARA_GRAVES_TABLE.'` WHERE `faraID`='.-$id;
	} else {
		$query	= 'DELETE FROM `'.FARA_GRAVES_TABLE.'` WHERE `faraID`='.$id;
	}
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($id>0) {
		$query	= 'INSERT INTO `'.FARA_GRAVES_TABLE.'` (`faraID`, `cmentarzID`, `zabytek`, `nieczytelny`, `dzieciecy`, `wygasa`, `p1`, `p2`, `p3`, `p4`, `p5`, `p6`, `p7`, `p8`) '.
		'VALUES ('.$id.','.$cmentarz.','.$zabytek.','.$nieczytelny.','.$dziecko.',"'.$wygasa.'",'.
		'"'.$P1.'",'.'"'.$P2.'",'.'"'.$P3.'",'.'"'.$P4.'",'.'"'.$P5.'",'.'"'.$P6.'",'.'"'.$P7.'",'.'"'.$P8.'")';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}

// Księga pochowanych
function loadBurieds ($path) {
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {	
	$info		= explode ('|', $line);			
	//  faraID, cmentarz, nazwisko, imie, data ur., data śmierci, P1..P8
	$id			= intval (trim ($info [0]));	
	if ($id==0) continue;
	$cmentarz	= $info [1];	
	$nazwisko	= $this->unpackText ($info [2]);
	$imie		= $this->unpackText ($info [3]);
	$dataUr		= $info [4];
	$dataSm		= $info [5];	
	$P1			= $this->unpackText ($info [6]);	
	$P2			= $this->unpackText ($info [7]);	
	$P3			= $this->unpackText ($info [8]);	
	$P4			= $this->unpackText ($info [9]);	
	$P5			= $this->unpackText ($info [10]);	
	$P6			= $this->unpackText ($info [11]);	
	$P7			= $this->unpackText ($info [12]);	
	$P8			= $this->unpackText ($info [13]);	
	$grave		= (array_count_values ($info) > 14 ? intval (trim ($info [14])) : 0);
	if ($id<0) {
		$query	= 'DELETE FROM `'.FARA_BURIEDS_TABLE.'` WHERE `faraID`='.-$id;		
	} else {
		$query	= 'DELETE FROM `'.FARA_BURIEDS_TABLE.'` WHERE `faraID`='.$id;		
	}	
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($id>0) {
		$query	= 'INSERT INTO `'.FARA_BURIEDS_TABLE.'` (`faraID`, `cmentarzID`, `nazwisko`, `imie`, `dataUrodzenia`, `dataSmierci`, `p1`, `p2`, `p3`, `p4`, `p5`, `p6`, `p7`, `p8`, `grvid`) '.
		'VALUES ('.$id.','.$cmentarz.',"'.$nazwisko.'","'.$imie.'","'.$dataUr.'","'.$dataSm.'",'.
		'"'.$P1.'",'.'"'.$P2.'",'.'"'.$P3.'",'.'"'.$P4.'",'.'"'.$P5.'",'.'"'.$P6.'",'.'"'.$P7.'",'.'"'.$P8.'",'.$grave.')';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}

// Księga pochowanych - archiwum
function loadBuriedsArchive ($path) {
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, cmentarz, nazwisko, imie, data ur., data śmierci, P1..P8, powod
	$id			= intval (trim ($info [0]));	
	if ($id==0) continue;
	$cmentarz	= $info [1];	
	$nazwisko	= $this->unpackText ($info [2]);
	$imie		= $this->unpackText ($info [3]);
	$dataUr		= $info [4];
	$dataSm		= $info [5];	
	$P1			= $this->unpackText ($info [6]);	
	$P2			= $this->unpackText ($info [7]);	
	$P3			= $this->unpackText ($info [8]);	
	$P4			= $this->unpackText ($info [9]);	
	$P5			= $this->unpackText ($info [10]);	
	$P6			= $this->unpackText ($info [11]);	
	$P7			= $this->unpackText ($info [12]);	
	$P8			= $this->unpackText ($info [13]);	
	$powod		= $this->unpackText ($info [14]);	
	$grave		= (array_count_values ($info) > 15 ? intval (trim ($info [15])) : 0);
	if ($id<0) {
		$query	= 'DELETE FROM `'.FARA_BURIEDS_ARCHIVE_TABLE.'` WHERE `faraID`='.-$id;
	} else {
		$query	= 'DELETE FROM `'.FARA_BURIEDS_ARCHIVE_TABLE.'` WHERE `faraID`='.$id;
	}
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($id>0) {
		$query	= 'INSERT INTO `'.FARA_BURIEDS_ARCHIVE_TABLE.'` (`faraID`, `cmentarzID`, `nazwisko`, `imie`, `dataUrodzenia`, `dataSmierci`, `p1`, `p2`, `p3`, `p4`, `p5`, `p6`, `p7`, `p8`, `powod`, `grvid`) '.
		'VALUES ('.$id.','.$cmentarz.',"'.$nazwisko.'","'.$imie.'","'.$dataUr.'","'.$dataSm.'",'.
		'"'.$P1.'",'.'"'.$P2.'",'.'"'.$P3.'",'.'"'.$P4.'",'.'"'.$P5.'",'.'"'.$P6.'",'.'"'.$P7.'",'.'"'.
		$P8.'", "'.$powod.'",'.$grave.')';		
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}
// Indeks cmentarzy
function loadCemeteries ($path) {
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, nazwa, adres, liczba poziomów, P1..P8
	$id			= intval (trim ($info [0]));	
	if ($id==0) continue;
	$nazwa		= $this->unpackText ($info [1]);	
	$adres		= $this->unpackText ($info [2]);
	$poziomy	= $info [3];
	$P1			= $this->unpackText ($info [4]);	
	$P2			= $this->unpackText ($info [5]);	
	$P3			= $this->unpackText ($info [6]);	
	$P4			= $this->unpackText ($info [7]);	
	$P5			= $this->unpackText ($info [8]);	
	$P6			= $this->unpackText ($info [9]);	
	$P7			= $this->unpackText ($info [10]);	
	$P8			= $this->unpackText ($info [11]);	
	if ($id<0) {		
		$query	= 'DELETE FROM `'.FARA_CEMETERIES_TABLE.'` WHERE `faraID`='.-$id;		
	} else {
		$query	= 'DELETE FROM `'.FARA_CEMETERIES_TABLE.'` WHERE `faraID`='.$id;
	}
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($id>0) {
		$query	= 'INSERT INTO `'.FARA_CEMETERIES_TABLE.'` (`faraID`, `nazwa`, `adres`, `poziomy`, `p1`, `p2`, `p3`, `p4`, `p5`, `p6`, `p7`, `p8`) '.
		'VALUES ('.$id.',"'.$nazwa.'","'.$adres.'",'.$poziomy.','.'"'.
		$P1.'",'.'"'.$P2.'",'.'"'.$P3.'",'.'"'.$P4.'",'.'"'.$P5.'",'.'"'.$P6.'",'.'"'.$P7.'",'.'"'.$P8.'")';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	} else {
		// Kasowanie całego cmentarza
		$query	= 'DELETE FROM `'.FARA_GRAVES_TABLE.'` WHERE `cmentarzID`='.-$id;
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
		$query	= 'DELETE FROM `'.FARA_BURIEDS_TABLE.'` WHERE `cmentarzID`='.-$id;
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
		$query	= 'DELETE FROM `'.FARA_BURIEDS_ARCHIVE_TABLE.'` WHERE `cmentarzID`='.-$id;
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
		$query	= 'DELETE FROM `'.FARA_GRAVES_PICTURES_TABLE.'` WHERE `cmentarzID`='.-$id;
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}

// Zdjęcia
function loadPictures ($path) {
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, cmentarz, id grobu, typ, plik lokalny lub URL, plik doccelowy (puste dla URL)
	$id			= intval (trim ($info [0]));	
	if ($id==0) continue;
	$cmentarz	= $info [1];	
	$grob		= $info [2];
	$typ		= $info [3];
	$plikLokalny= $this->unpackText ($info [4]);	
	$plikDocelowy= $this->unpackText ($info [5]);	
	if ($id<0) {
		$query	= 'DELETE FROM `'.FARA_GRAVES_PICTURES_TABLE.'` WHERE `faraID`='.-$id;
	} else {
		$query	= 'DELETE FROM `'.FARA_GRAVES_PICTURES_TABLE.'` WHERE `faraID`='.$id;
	}
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($id>0) {
		$query	= 'INSERT INTO `'.FARA_GRAVES_PICTURES_TABLE.'` (`faraID`, `cmentarzID`, `grobID`, `typ`, `plikLokalny`, `plikNaSerwerze`) '.
		'VALUES ('.$id.','.$cmentarz.','.$grob.','.$typ.',"'.$plikLokalny.'",'.'"'.$plikDocelowy.'")';		
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}
		
function unixTime ($date) {
$year 	= intval ($date/10000);
$month	= intval (($date%10000)/100);
$day	= $date%100;
$time	= mktime (0, 0, 0, $month, $day, $year);
return $time;
}

function fileNameExtension ($fileName) {
$elements = explode ('.', $fileName);
if (!$elements or count ($elements)==1) return '';
return strtolower ($elements[count($elements)-1]);
}

function poziomy ($cmentarzID) {
$handle = mysql_query ('SELECT `poziomy` FROM '.FARA_CEMETERIES_TABLE.' WHERE `faraID`='.$cmentarzID);
if (!$handle) return -1;
if (mysql_num_rows ($handle)==0) return 0;
$record = @mysql_fetch_object ($handle);
return $record->poziomy;
}

function szukaj () {
$_nazwisko	= (func_num_args () > 0) ? trim(func_get_arg (0)) : "";
$_imie 		= (func_num_args () > 1) ? trim(func_get_arg (1)) : "";
$_dataUr 	= (func_num_args () > 2) ? trim(func_get_arg (2)) : "";
$_dataSm 	= (func_num_args () > 3) ? trim(func_get_arg (3)) : "";
$_cmentarz 	= (func_num_args () > 4) ? func_get_arg (4) : 0;

$query	= 'SELECT * FROM `'.FARA_BURIEDS_TABLE.'` WHERE `nazwisko`="'.$_nazwisko. '"';
if (trim($_imie)<>"") $query .= ' and `imie`="'.trim($_imie).'"';
if (trim($_dataUr)<>"") $query .= ' and `dataUrodzenia`="'.trim($_dataUr).'"';
if (trim($_dataSm)<>"") $query .= ' and `dataSmierci`="'.trim($_dataSm).'"';
if ($_cmentarz<>0) $query .= ' and `cmentarzID`='.$_cmentarz;
$query .= ' ORDER BY nazwisko, imie';
$handle = mysql_query ($query);
// DB CONNECTION ERROR
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "szukaj" ('.$query.')'); 
	return '';
}
$pochowani = array();

$rowsInResult = mysql_num_rows ($handle);
// NOT FOUND
if ($rowsInResult == 0) return 0;
for ($row=0; $row<$rowsInResult; $row++) {
	$record 	= @mysql_fetch_assoc ($handle);
	$pochowany	= new FaraPochowani ();
	$pochowany->faraID 			= $record["faraID"];
	$pochowany->nazwisko		= $record["nazwisko"];
	$pochowany->imie			= $record["imie"];
	$pochowany->dataUrodzenia	= $record["dataUrodzenia"];
	$pochowany->dataSmierci		= $record["dataSmierci"];	
	$poziomyLiczba = $this->poziomy($record["cmentarzID"]);
	$query = 'SELECT * FROM '.FARA_GRAVES_TABLE.' WHERE `cmentarzID`='.$record["cmentarzID"];	
	for ($poziom=1;$poziom<=$poziomyLiczba; $poziom++) {
		$query .= ' and (trim(UCASE(p'.$poziom.'))="'.trim(strtoupper($record['p'.$poziom])).'")';
	}	
	$querySet = mysql_query ($query);
	if (!$querySet) {
		//mysql_free_result($querySet);
		return -1;
	}
	if (mysql_num_rows($querySet)==0) {
		$pochowany->grob=0;
	} else if (mysql_num_rows($querySet)>1) {
		$pochowany->grob=-1;	// Błąd użytkownika:
								// w bazie danych jest więcej grobów o tej samej lokalizacji
	} else {
		$result = @mysql_fetch_assoc ($querySet);
		$pochowany->grob = new FaraGrobInfo ();
		$pochowany->grob->poziomy = $poziomyLiczba;
		$pochowany->grob->faraIDgrobu = $result["faraID"];
		$pochowany->grob->faraIDcmentarza = $result["cmentarzID"];
		$pochowany->grob->zabytkowy = $result["zabytkowy"];
		$pochowany->grob->nieczytelny = $result["nieczytelny"];
		$pochowany->grob->dzieciecy = $result["dzieciecy"];
		$pochowany->grob->wygasa = $result["wygasa"];
		$pochowany->grob->p1 = $result["p1"];
		$pochowany->grob->p2 = $result["p2"];
		$pochowany->grob->p3 = $result["p3"];
		$pochowany->grob->p4 = $result["p4"];
		$pochowany->grob->p5 = $result["p5"];
		$pochowany->grob->p6 = $result["p6"];
		$pochowany->grob->p7 = $result["p7"];
		$pochowany->grob->p8 = $result["p8"];
		for ($poziom=1;$poziom<=$poziomyLiczba; $poziom++) {			
			$pochowany->grob->lokalizacja .= (($poziom>1) ? '-' : '').trim($result["p".$poziom]);
		}
		$picturesSet = mysql_query ('SELECT * FROM '.FARA_GRAVES_PICTURES_TABLE.' WHERE '.
						'`grobID`='.$pochowany->grob->faraIDgrobu);		
		$picturesCount = mysql_num_rows ($picturesSet);		
		for ($pictureNo=0;$pictureNo<$picturesCount;$pictureNo++) {
			$picture = @mysql_fetch_assoc($picturesSet);			
			$pictureContainer = new FaraGrobFotografia ();
			$pictureContainer->faraID = $picture["faraID"];
			$pictureContainer->typ = $picture["typ"];
			$pictureContainer->nazwa = ($pictureContainer->typ==0) ? $picture["plikNaSerwerze"]:$picture["plikLokalny"];				
			$pochowany->grob->fotografie[]=$pictureContainer;
		}
		mysql_free_result($picturesSet);
	}	
	mysql_free_result($querySet);
	$pochowani[] = $pochowany;
}
mysql_free_result($handle);
return $pochowani;
}

} // END OF CLASS DEFINITION

class FaraPochowani {
	var $faraID;
	var $nazwisko;
	var $imie;
	var $dataUrodzenia;
	var $dataSmierci;
	var $grob;
}

class FaraGrobFotografia {
	var $faraID;
	var $typ;	// 0-plik na serwerze, 1-adres URL
	var $nazwa;
}

class FaraGrobInfo {
	var $faraIDgrobu = 0;
	var $faraIDcmentarza = 0;
	var $zabytkowy = 0;
	var $nieczytelny = 0;
	var $dzieciecy = 0;
	var $wygasa = "";
	var $nazwisko = "";
	var $imie = "";
	var $dataUrodzenia = "";
	var $dataSmierci = "";
	var $P1 = "";
	var $P2 = "";
	var $P3 = "";
	var $P4 = "";
	var $P5 = "";
	var $P6 = "";
	var $P7 = "";
	var $P8 = "";
	var $fotografie = array();
}

?>